from __future__ import annotations

import typing

from digitalhub.entities.task._base.entity import Task

if typing.TYPE_CHECKING:
    from digitalhub_runtime_python.entities.task.python_serve.spec import TaskSpecPythonServe
    from digitalhub_runtime_python.entities.task.python_serve.status import TaskStatusPythonServe

    from digitalhub.entities._base.entity.metadata import Metadata


class TaskPythonServe(Task):
    """
    TaskPythonServe class.
    """

    def __init__(
        self,
        project: str,
        name: str,
        uuid: str,
        kind: str,
        metadata: Metadata,
        spec: TaskSpecPythonServe,
        status: TaskStatusPythonServe,
        user: str | None = None,
    ) -> None:
        super().__init__(project, name, uuid, kind, metadata, spec, status, user)

        self.spec: TaskSpecPythonServe
        self.status: TaskStatusPythonServe
